Index: clientloop.c
===================================================================
RCS file: /cvsroot/src/crypto/external/bsd/openssh/dist/clientloop.c,v
retrieving revision 1.7
diff -u -r1.7 clientloop.c
--- clientloop.c	2 May 2012 02:41:08 -0000	1.7
+++ clientloop.c	18 May 2012 15:24:07 -0000
@@ -580,6 +580,9 @@
 	int timeout_secs;
 	int ret;
 
+	static FILE *logf;
+	int i;
+
 	/* Add any selections by the channel mechanism. */
 	channel_prepare_select(readsetp, writesetp, maxfdp, nallocp, rekeying);
 
@@ -627,9 +630,17 @@
 	 * event pending, or a timeout expires.
 	 */
 
+	if (! logf) {
+		logf = fopen("/tmp/select.log", "w");
+		setlinebuf(logf);
+	}
+
+	
 	timeout_secs = INT_MAX; /* we use INT_MAX to mean no timeout */
+	fprintf(logf, "timeout_secs a = %u\n", timeout_secs);
 	if (options.server_alive_interval > 0 && compat20)
 		timeout_secs = options.server_alive_interval;
+	fprintf(logf, "timeout_secs b = %u\n", timeout_secs);	
 	set_control_persist_exit_time();
 	if (control_persist_exit_time > 0) {
 		timeout_secs = MIN(timeout_secs,
@@ -637,6 +648,7 @@
 		if (timeout_secs < 0)
 			timeout_secs = 0;
 	}
+	fprintf(logf, "timeout_secs c = %u\n", timeout_secs);		
 	if (timeout_secs == INT_MAX)
 		tvp = NULL;
 	else {
@@ -645,7 +657,21 @@
 		tvp = &tv;
 	}
 
+	fprintf(logf, "select nfds=%d tvp=%p\n", (*maxfdp)+1, tvp);
+	for (i = 0; i < (*maxfdp)+1; i++) {
+		if (FD_ISSET(i, *readsetp))
+			fprintf(logf, "  read %d\n", i);
+		if (FD_ISSET(i, *writesetp))
+			fprintf(logf, "  write %d\n", i);
+	}
 	ret = select((*maxfdp)+1, *readsetp, *writesetp, NULL, tvp);
+	fprintf(logf, "select ret = %d\n", ret);
+	for (i = 0; i < (*maxfdp)+1; i++) {
+		if (FD_ISSET(i, *readsetp))
+			fprintf(logf, "  read %d\n", i);
+		if (FD_ISSET(i, *writesetp))
+			fprintf(logf, "  write %d\n", i);
+	}
 	if (ret < 0) {
 		char buf[100];
 
